import random

import gsdl2

import settings
import weapon


class Enemy(object):

    size = None
    texture = None

    def __init__(self):
        if Enemy.size is None:
            w = settings.resolution[0] // 50
            Enemy.size = w, w
        w, h = Enemy.size
        self.x = random.randrange(settings.playfield_rect.left, settings.playfield_rect.right - w)
        self.y = -h
        self.rect = gsdl2.Rect(self.x, self.y, w, h)
        surf = gsdl2.Surface(self.rect.size)
        surf.fill((255, 0, 0))
        if Enemy.texture is None:
            Enemy.texture = gsdl2.Texture(gsdl2.display.get_renderer(), surf)
        self.speed = (100.0, 75.0)[1]
        self.weapon = weapon.EnemyWeapon(
            self, range(6) + range(9, 16) + range(19, 24), shots_per_group=settings.enemy_shots_per_group)

    def draw_rect(self, interp):
        return self.rect

    def update(self, dt):
        self.y += self.speed * dt
        self.rect.y = self.y
        self.weapon.update(dt)


def enemy_factory(num=1, enemy_type=None):
    enemies = []
    for i in range(num):
        if enemy_type is None:
            enemy_type = Enemy
        enemies.append(enemy_type())
    return enemies
