import os

import gsdl2

import settings


def start_music():
    gsdl2.music.fadein(os.path.join(settings.music_dir, '05 Venus.ogg'), ms=1000)
    queue_music()


def stop_music():
    gsdl2.music.clear_queue()
    gsdl2.music.fadeout(1000)


def queue_music():
    gsdl2.music.queue(os.path.join(settings.music_dir, '05 Venus.ogg'))


def play_enemy_shoot():
    _enemy_shoot_channel.play(_enemy_shoot)


def play_player_shoot():
    _player_shoot.play()
    _player_shoot.set_volume(0.9)


def play_gain_weapon():
    _gain_weapon.play()


def play_lose_weapon():
    _lose_weapon.play()


gsdl2.init()
gsdl2.mixer.init()
gsdl2.mixer.set_reserved(1)

_enemy_shoot = gsdl2.mixer.Sound(os.path.join(settings.sound_dir, 'enemy_shoot.ogg'))
_player_shoot = gsdl2.mixer.Sound(os.path.join(settings.sound_dir, 'player_shoot.ogg'))
_gain_weapon = gsdl2.mixer.Sound(os.path.join(settings.sound_dir, 'gain_weapon.ogg'))
_lose_weapon = gsdl2.mixer.Sound(os.path.join(settings.sound_dir, 'lose_weapon.ogg'))

_enemy_shoot_channel = gsdl2.mixer.Channel(0)
